Loading...
Searching...
No Matches
BALL::QSAR::KPLSModel Class Reference

`#include <BALL/QSAR/kplsModel.h>`

Inheritance diagram for BALL::QSAR::KPLSModel:

## Public Member Functions

Constructors and Destructors
| KPLSModel (const QSARData &q, int k_type, double p1, double p2=-1)
| KPLSModel (const QSARData &q, Eigen::VectorXd &w)
| KPLSModel (const QSARData &q, String s1, String s2)
| KPLSModel (const QSARData &q, const LinearModel &lm, int column)
| ~KPLSModel ()
Accessors
void | train ()
bool | optimizeParameters (int k, int no_steps)
int | getNoComponents ()
void | setNoComponents (int d)
const Eigen::MatrixXd * | getU ()
void | setParameters (vector< double > &v)
vector< double > | getParameters () const
Public Member Functions inherited from BALL::QSAR::KernelModel
| KernelModel (const QSARData &q, int k_type, double p1, double p2)
| KernelModel (const QSARData &q, String f, String g)
| KernelModel (const QSARData &q, Eigen::VectorXd &w)
| KernelModel (const QSARData &q, const LinearModel &lm, int column)
| ~KernelModel ()
virtual void | saveToFile (string filename)
virtual void | readFromFile (string filename)
virtual Eigen::VectorXd | predict (const vector< double > &substance, bool transform)
void | operator= (const Model &m)
| NonLinearModel (const QSARData &q)
| ~NonLinearModel ()
Public Member Functions inherited from BALL::QSAR::RegressionModel
| RegressionModel (const QSARData &q)
| ~RegressionModel ()
virtual EIGEN_MAKE_ALIGNED_OPERATOR_NEW void | operator= (const RegressionModel &m)
const Eigen::MatrixXd * | getTrainingResult () const
void | show ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
void | deleteDescriptorIDs ()
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)
Public Member Functions inherited from BALL::QSAR::LatentVariableModel
| LatentVariableModel ()
const Eigen::MatrixXd * | getLatentVariables ()
const Eigen::MatrixXd * | getWeights ()
const Eigen::MatrixXd * | getLoadings ()

## Protected Attributes

Attributes
Eigen::MatrixXd | U_
int | no_components_
Eigen::MatrixXd | K_
Protected Attributes inherited from BALL::QSAR::RegressionModel
Eigen::MatrixXd | training_result_
Eigen::RowVectorXd | offsets_
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_
Protected Attributes inherited from BALL::QSAR::LatentVariableModel
Eigen::MatrixXd | latent_variables_
Eigen::MatrixXd | loadings_
Eigen::MatrixXd | weights_

## Additional Inherited Members

Kernel * | kernel
RegressionValidation * | validation
const QSARData * | data
Validation * | model_val
void | calculateOffsets ()
void | readKernelParametersFromFile (std::ifstream &in)
void | saveKernelParametersToFile (std::ofstream &out)
void | saveTrainingResult (std::ofstream &out)
void | readTrainingResult (std::ifstream &input, int no_substances, int no_y)
void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation, int no_coefficients)
void | saveDescriptorInformationToFile (std::ofstream &out)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()

## Detailed Description

kernel partial-least-squares class

Definition at line 26 of file kplsModel.h.

## Constructor & Destructor Documentation

## KPLSModel() [1/4]

BALL::QSAR::KPLSModel::KPLSModel | ( | const QSARData & | q,
|  | int | k_type,
|  | double | p1,
|  | double | p2 = -1 )

## KPLSModel() [2/4]

BALL::QSAR::KPLSModel::KPLSModel | ( | const QSARData & | q,
|  | Eigen::VectorXd & | w )

## KPLSModel() [3/4]

BALL::QSAR::KPLSModel::KPLSModel | ( | const QSARData & | q,
|  | String | s1,
|  | String | s2 )

## KPLSModel() [4/4]

BALL::QSAR::KPLSModel::KPLSModel | ( | const QSARData & | q,
|  | const LinearModel & | lm,
|  | int | column )

## ~KPLSModel()

BALL::QSAR::KPLSModel::~KPLSModel | ( |  | ) |

## Member Function Documentation

## getNoComponents()

int BALL::QSAR::KPLSModel::getNoComponents | ( |  | ) |

returns the number of latente variables (=PLS components)

## getParameters()

vector< double > BALL::QSAR::KPLSModel::getParameters | ( |  | ) | const

virtual

Reimplemented from BALL::QSAR::Model.

## getU()

const Eigen::MatrixXd * BALL::QSAR::KPLSModel::getU | ( |  | ) |

returns a pointer to the PLS Y-scores matrix U

## optimizeParameters()

bool BALL::QSAR::KPLSModel::optimizeParameters | ( | int | k,
|  | int | no_steps )

virtual

tries to find the optimal number of latente variables (=PLS components)

Reimplemented from BALL::QSAR::Model.

## setNoComponents()

void BALL::QSAR::KPLSModel::setNoComponents | ( | int | d | ) |

## setParameters()

void BALL::QSAR::KPLSModel::setParameters | ( | vector< double > & |  | ) |

virtual

sets the model parameters according to the given values.

Reimplemented from BALL::QSAR::Model.

## train()

void BALL::QSAR::KPLSModel::train | ( |  | ) |

virtual

Starts training the model.

Implements BALL::QSAR::Model.

## Member Data Documentation

## no_components_

int BALL::QSAR::KPLSModel::no_components_

protected

Definition at line 74 of file kplsModel.h.

## U_

Eigen::MatrixXd BALL::QSAR::KPLSModel::U_

protected

Definition at line 72 of file kplsModel.h.